/*
 * The contents of this file are
 * published under the Mozilla Public License 1.1
 */
/*
__IMPORT__
	(
	'chrome://mozlib/content/lib/js/assert/',
	'argument.js',
	'processor.js',
	'abstract_failure.js',
	'failure.js',
	'warning.js',
	'stat.js',
	'reporter.js'
	);
*/


//@@@@@@@@@@@@@@@@
function ASSERT_Tester		//<c><a>public<d>Unit tester class
(
_iframeId		//<p>string<d>Test reporter iframe ID
){
//================
this.ASSERT_Tester = function		//<m>void<a>private<d>class constructor
(
iframeId		//<p>string<d>Test reporter iframe ID
){
this.className	= 'ASSERT_Tester';
this.iframeId	= iframeId;
this.set_ASSERT_Tester();
}//</m>ASSERT_Tester



//================
this.set_ASSERT_Tester = function		//<m>void<a>private<d>Instance i12n
(){
this.processor	= null;
this.reporter	= new ASSERT_Reporter(this.iframeId);
this.argument	= new ASSERT_Argument(/*undefined*/);
}//</m>set_ASSERT_Tester



//================
this.get_reporter = function		//<m>ASSERT_Reporter<a>public<d>Get reporter member
(){
return this.reporter;
}//</m>get_reporter



//================
this.setAssert = function		//<m>boolean<a>private<d>Check whether assertion has to be executed
(
checking,	//<p>boolean<d>assertion checking flag
arg0,		//<p>any<d>argument to test
arg1		//<p>any<d>expected argument || second argument to test in compare
){
if(this.isShortAssert(checking) || this.isTrueAssert(checking)){
	this.processor = new ASSERT_Processor(arg0, arg1);
	this.reporter.setChecked();
	return true;	
	}
return false;
}//</m>setAssert


//================
this.check = function		//<m>(boolean)int<a>private<d>
(
operation,	//<p>string<d>assertion operation
arg0,		//<p>any<d>argument to test
arg1,		//<p>any<d>expected argument 
checking,	//<p>boolean<d>assertion checking flag --optional
id			//<p>string<d>calling function name and comment --optional
){
if(!this.setAssert(checking, arg0)) return ASSERT_SKIP;
if(this.processor.check(operation)) return ASSERT_TRUE;
this.reporter.setFailure(new ASSERT_Failure(this.getReportComment(checking, id), arg0, arg1));
return ASSERT_FALSE;
}//</m>check


//================
this.compute = function		//<m>(boolean)int<a>private<d>
(
operation,	//<p>string<d>assertion operation
arg0,		//<p>any<d>argument to test
arg1,		//<p>any<d>expected argument 
checking,	//<p>boolean<d>assertion checking flag --optional
id			//<p>string<d>calling function name and comment --optional
){
if(!this.setAssert(checking, arg0)) return ASSERT_SKIP;
if(this.processor.compute(operation)) return ASSERT_TRUE;
this.reporter.setFailure(new ASSERT_Failure(this.getReportComment(checking, id), arg0, arg1));
return ASSERT_FALSE;
}//</m>compute


//================
this.compare = function		//<m>(boolean)int<a>public<d>
(
operation,	//<p>string<d>assertion operation
arg0,		//<p>any<d>argument to compare
arg1,		//<p>any<d>argument to compare
checking,	//<p>boolean<d>assertion checking flag --optional
id			//<p>string<d>calling function name and comment --optional
){
if(!this.setAssert(checking, arg0, arg1)) return ASSERT_SKIP;
if(this.processor.compare(operation)) return ASSERT_TRUE;
var
/*string*/assertion = (operation=='==') ? '' : operation;
this.reporter.setFailure(new ASSERT_Failure(this.getReportComment(checking, id), arg0, assertion + arg1));
return ASSERT_FALSE;
}//</m>compare


//================
this.isTrue = function		//<m>(boolean)int<a>public<d>
(
arg0,		//<p>any<d>argument to test
checking,	//<p>boolean<d>assertion checking flag --optional
id			//<p>string<d>calling function name and comment --optional
){
return this.check('', arg0, 'true', checking, id);
}//</m>isTrue


//================
this.isFalse = function		//<m>(boolean)int<a>public<d>
(
arg0,		//<p>any<d>argument to test
checking,	//<p>boolean<d>assertion checking flag --optional
id			//<p>string<d>calling function name and comment --optional
){
return this.check('!', arg0, 'false', checking, id);
}//</m>isFalse


//================
this.isNull = function		//<m>(boolean)int<a>public<d>
(
arg0,		//<p>any<d>argument to test
checking,	//<p>boolean<d>assertion checking flag --optional
id			//<p>string<d>calling function name and comment --optional
){
return this.check('null==', arg0, 'null', checking, id);
}//</m>isNull


//================
this.isNotNull = function		//<m>(boolean)int<a>public<d>
(
arg0,		//<p>any<d>argument to test
checking,	//<p>boolean<d>assertion checking flag --optional
id			//<p>string<d>calling function name and comment --optional
){
return this.check('null!=', arg0, '!= null', checking, id);
}//</m>isNotNull


//================
this.isUndefined = function		//<m>(boolean)int<a>public<d>
(
arg0,		//<p>any<d>argument to test
checking,	//<p>boolean<d>assertion checking flag --optional
id			//<p>string<d>calling function name and comment --optional
){
return this.check('undefined==', arg0, 'undefined', checking, id);
}//</m>isUndefined


//================
this.isNotUndefined = function		//<m>(boolean)int<a>public<d>
(
arg0,		//<p>any<d>argument to test
checking,	//<p>boolean<d>assertion checking flag --optional
id			//<p>string<d>calling function name and comment --optional
){
return this.check('undefined!=', arg0, '!= undefined', checking, id);
}//</m>isNotUndefined


//================
this.isNumber = function		//<m>(boolean)int<a>public<d>
(
arg0,		//<p>any<d>argument to test
checking,	//<p>boolean<d>assertion checking flag --optional
id			//<p>string<d>calling function name and comment --optional
){
return this.compute('!', arg0, 'number', checking, id);
}//</m>isNumber


//================
this.isNotNumber = function		//<m>(boolean)int<a>public<d>
(
arg0,		//<p>any<d>argument to test
checking,	//<p>boolean<d>assertion checking flag --optional
id			//<p>string<d>calling function name and comment --optional
){
return this.compute('', arg0, 'NaN', checking, id);
}//</m>isNotNumber


//================
this.isEqual = function		//<m>(boolean)int<a>public<d>
(
arg1,		//<p>any<d>argument to test
arg0,		//<p>any<d>argument to test
checking,	//<p>boolean<d>assertion checking flag --optional
id			//<p>string<d>calling function name and comment --optional
){
return this.compare('==', arg0, arg1, checking, id);
}//</m>isEqual


//================
this.isNotEqual = function		//<m>(boolean)int<a>public<d>
(
arg1,		//<p>any<d>argument to test
arg0,		//<p>any<d>argument to test
checking,	//<p>boolean<d>assertion checking flag --optional
id			//<p>string<d>calling function name and comment --optional
){
return this.compare('!=', arg0, arg1, checking, id);
}//</m>isNotEqual


//================
this.warn = function		//<m>(boolean)int<a>public<d>
(
warning,	//<p>string<d>Message
checking	//<p>boolean<d>assertion checking flag --optional
){
if(!this.setAssert(checking, true)) return ASSERT_SKIP;
this.reporter.setFailure(new ASSERT_Warning(warning));
return ASSERT_FALSE;
}//</m>warn


//================
this.getReportComment = function		//<m>(boolean)int<a>private<d>
(
checking,	//<p>boolean<d>assertion checking flag --optional
id			//<p>string<d>calling function name and comment --optional
){
return this.argument.isString(checking) ? checking : id;
}//</m>getReportComment


//================
this.isShortAssert = function		//<m>(boolean)int<a>private<d>
(
checking		//<p>boolean<d>assertion checking flag --optional
){
return this.argument.isUndefined(checking) || this.argument.isString(checking);	//assertion function called without using checking argument
}//</m>isShortAssert


//================
this.isTrueAssert = function		//<m>(boolean)int<a>private<d>
(
checking		//<p>boolean<d>assertion checking flag --optional
){
return this.argument.isBoolean(checking) && checking;
}//</m>isTrueAssert



const
/*(boolean)int*/
ASSERT_FALSE= 0,
ASSERT_TRUE	= 1,
ASSERT_SKIP	= 2;



this.ASSERT_Tester(_iframeId);
}//</c>ASSERT_Tester

