/*
 * The contents of this file are
 * published under the Mozilla Public License 1.1
 */
//@@@@@@@@@@@@@@@@
function IO_file_Descriptor		//<c><a>protected<d>File descriptor class
(){
//================
this.IO_file_Descriptor = function		//<m>void<a>private<d>class constructor
(){
this.className		= 'IO_file_Descriptor';
this.setIn();
}//</m>IO_file_Descriptor



//================
this.setIn = function		//<m>void<a>private<d>Instance i12n
(){
this.errorNotifier = new ERROR_Notifier(this.className);
}//</m>setIn



//================
this.getSize = function		//<m>int<a>protected<d>Get the size of the handled file/dir
(){
try{
	return this.handle.fileSize;
	}
catch(e){
	this.errorNotifier.setOut(e, this.K.ERROR.SIZE_READ);
	return null;
	}
}//</m>getSize



//================
this.getDate = function		//<m>int<a>protected<d>Get the date of the handled file/dir
(){
try{
	return new Date(this.handle.lastModifiedTime).toLocaleString();
	}
catch(e){
	this.errorNotifier.setOut(e, this.K.ERROR.DATE_READ);
	return null;
	}
}//</m>getDate



this.K =
	{

	ERROR:
		{
		//NON FATAL
		NONE:					0,
		NO_SUCCESS:				1,

		//FATAL
		SIZE_READ:				-1,
		DATE_READ:				-2,
		FATAL:					0xFF		//end of error codes
		}
	};



this.IO_file_Descriptor();
}//</c>IO_file_Descriptor<d>&
/*
This component class manages handled file/dir information:
	size,
	date of modification
*/




