/*
 * The contents of this file are
 * published under the Mozilla Public License 1.1
 */
//@@@@@@@@@@@@@@@@
function IO_selector_Selector		//<c><a>public<d>File picker manager class
(
_label,			//<p>string<d>Dialog label
_mode,			//<p>string<d>Selection mode
_filterSet		//<p>Object<d>Label and filter expression
){
//================
this.IO_selector_Selector = function		//<m>void<a>private<d>class constructor
(
label,			//<p>string<d>Dialog label
mode,			//<p>string<d>Selection mode
filterSet		//<p>Object<d>Label and filterSet: {label:'string', flagSet:['string']}
){
this.className	= 'IO_selector_Selector';
this.label		= label;
this.mode		= mode;
this.filterSet	= filterSet;
this.setIn();
}//</m>IO_selector_Selector



//================
this.setIn = function		//<m>boolean<a>private<d>Instance i12n
(){
this.errorNotifier	= new ERROR_Notifier(this.className);
this.enable			= this.K.INSTANCE_DISABLED;
this.selection		= null;
if(this.setXPCOM() == this.K.ERROR.NONE){
	this.selector.init(window, this.label, this.selector[this.mode]);
	this.setFilterSet();
	}
}//</m>setIn



//================
this.setXPCOM = function		//<m>void<a>private<d>SetUp XPCOM interfaces
(){
try{
	this.selector = XPConnector.getInstance('nsIFilePicker');
	return this.K.ERROR.NONE;
	}
catch(e){
	return this.errorNotifier.setOut(e, this.K.ERROR.SERVICE_ACCESS);
	}
}//</m>setXPCOM



//================
this.setFilterSet = function		//<m>void<a>public<d>Set up filtering scheme
(){
if(this.mode != 'modeGetFolder'){
	try{
		var
		/*int*/flag = 0;
		if(this.filterSet) for(var i=0,m=this.filterSet.flagSet.length;i<m;i++) flag |= this.selector[this.filterSet.flagSet[i]];
		this.selector.appendFilters(flag || this.selector['filterAll']);
		}
	catch(e){
		return this.errorNotifier.setOut(e, this.K.ERROR.NO_SUCCESS);
		}
	}
this.enable = this.K.INSTANCE_ENABLED;
}//</m>setFilter



//================
this.setFilter = function		//<m>void<a>public<d>Set up a customized filtering scheme
(
label,			//<p>string<d>Filtering dialog label
extensions		//<p>string<d>Filter schemes, semi-colon separated
){
this.selector.appendFilter(label, extensions);
}//</m>setFilter



//================
this.setDirPath = function		//<m>boolean<a>public<d>Set up dialog directory path
(
handle		//<p>Object<d>Directory handle
){
this.selector.displayDirectory = handle;
}//</m>setDirPath



//================
this.setDialog = function		//<m>boolean<a>public<d>Show file dialog
(){
if(this.enable) this.selection = this.selector.show();
}//</m>setDialog



//================
this.getHandle = function		//<m>Object<a>public<d>Get handle of selected file
(){
return this.testSelection() ? this.selector.file : null;
}//</m>getHandle



//================
this.getPath = function		//<m>string<a>public<d>Get path of selected file
(){
return this.testSelection() ? this.selector.file.path : '';
}//</m>getPath



//================
this.getAppPath = function		//<m>string<a>private<d>Check whether file path is a chrome application path (appPath is in path)
(
path,		//<p>string<d>File path to test
appDir		//<p>string<d>Chrome applicatin directory name with trailing /
){
var
/*int*/index = path.indexOf(appDir);
return (index > -1) ? path.substr(index + appDir.length) : '';
}//</m>getAppPath



//================
this.getChromePath = function		//<m>string<a>public<d>Get path of selected file
(
appDir		//<p>string<d>Chrome applicatin directory name with trailing /
){
return this.getAppPath(this.getPath(), appDir);
}//</m>getPath



//================
this.getChromeSource = function		//<m>string<a>public<d>Get a chrome application source file
(
appDir		//<p>string<d>Chrome applicatin directory name with trailing /
){
this.setDialog();
return this.getChromePath(appDir);

}//</m>getChromeSource



//================
this.testSelection = function		//<m>boolean<a>public<d>Check whether a file has already been selected
(){
return (this.selection != this.K.NO_SELECTION) && (this.selection != this.K.FILE_CANCEL);
}//</m>testSelection



this.K =
	{
	INSTANCE_ENABLED:			true,
	INSTANCE_DISABLED:			false,

	/* nsIFilePicker constants
	modeOpen: 			0,       // Load a file or directory
	modeSave: 			1,       // Save a file or directory
	modeGetFolder: 		2,       // Select a directory

	filterAll: 			1 << 0,    // *.*
	filterHTML: 		1 << 1,    // *.html, *.htm
	filterText: 		1 << 2,    // *.txt
	filterImages: 		1 << 3,    // *.png, *.gif, *.jpg, *.jpeg
	filterXML: 			1 << 4,    // *.xml
	filterXUL: 			1 << 5,    // *.xul
	*/
	FILE_CANCEL:		1,
	FILE_SELECTION:		0,
	FILE_REPLACE:		2,
	NO_SELECTION:		null,

	ERROR:
		{
		//NON FATAL
		NONE:					0,
		NO_SUCCESS:				1,
		NO_PROCESSING:			2,

		//FATAL
		SERVICE_ACCESS:			-1,
		FATAL:					0xFF		//end of error codes
		}
	}



this.IO_selector_Selector(_label, _mode, _filterSet);
}//</c>IO_selector_Selector

