/*
 * The contents of this file are
 * published under the Mozilla Public License 1.1
 */
//################
function LANG_object_inspect		//<f>string<a>public<d>Inspect the object
(
object,		//<p>Object<d>Object to inspect
depth		//<p>int<d>Inspection depth
){
depth = depth || '';
var
/*string*/out = '';
for(var k in object){
	if(typeof(object[k]) == 'function') out += sprintf(depth + '[ %s ] function\n', k);
	else{
		out += sprintf(depth + '[ %s ]', k);
		out += (typeof(object[k]) == 'object') ? '\n' + LANG_object_inspect(object[k], depth + '........') : sprintf(' %s\n', object[k]);
		}
	}
return out;
}//</f>LANG_object_inspect



const /*string*/
TYPEOF_STRING = 'string', TYPEOF_ISODATE = 'ISOdate',
TYPEOF_INT = 'int', TYPEOF_FLOAT = 'float',
TYPEOF_BOOLEAN = 'boolean',
TYPEOF_NUMARRAY = 'narray', TYPEOF_HASHARRAY = 'harray',
TYPEOF_OBJECT = 'object';
const /*RegExp*/
TYPEOF_CONSTRUCTOR_PATTERN	= /(string|number|array|boolean|object)/,
TYPEOF_ISODATE_PATTERN		= /\d{4}-\d{2}-\d{2}T\d{2}:\d{2}:\d{2}(\.\d{1,3})?/;



//################
function LANG_object_getType
(
object		//<p>Object<d>Object to test
){
var
/*string*/typeSet = object.constructor.toString().toLowerCase().match(TYPEOF_CONSTRUCTOR_PATTERN);
if(!typeSet) return '';
switch(typeSet[1]){
	case 'number':	return (object.toString().indexOf('.')==-1) ? TYPEOF_INT : TYPEOF_FLOAT;	//floating-point numbers have dot
	case 'boolean':	return BOOLEAN_TYPE;
	case 'array':	return object.length ? TYPEOF_NUMARRAY : TYPEOF_HASHARRAY;	//numeric arrays have length, not hash arrays
	case 'object':	return TYPEOF_OBJECT;
	default: 		return object.match(TYPEOF_ISODATE_PATTERN) ? TYPEOF_ISODATE : TYPEOF_STRING;
	}
}//</f>LANG_object_getType



//################
function LANG_object_getReplica		//<f>Object<a>public<d>Make a deep copy of a variable
(
original		//<p>any<d>Original variable
){
if((original === null) || ((typeof original) != 'object')) return original;
var
/*any*/replica;
if(original.length === undefined){		//Object
	replica = new Object();
	for(var k in original) replica[k] = LANG_object_getReplica(original[k]);
	}
else{									//Array
	replica = new Array();
	for(var i=0,m=original.length;i<m;i++) replica[i] = LANG_object_getReplica(original[i]);
	}
return replica;
}//</f>LANG_object_getReplica




