/*
 * The contents of this file are
 * published under the Mozilla Public License 1.1
 */
/*
__IMPORT__
	(
	"chrome://mozlib/content/lib/js/rdfapi/",
	"store.js",
	"nsi_store.js",
	"model.js"
	);
*/


//@@@@@@@@@@@@@@@@
function RDFAPI_NSIModel		//<c><e>RDFAPI_Store<a>protected<d>RDF model class
(
_storeURL,		//<p>string<d>URL or null for in-memory model
_storage		//<p>int<d>Storage mode according to loading process
){
const ASSERTING = true;
//================
this.RDFAPI_NSIModel = function		//<m>void<a>private<d>class constructor
(
storeURL,	//<p>string<d>URL or empty string for in-memory model
storage		//<p>int<d>Storage mode according to loading process
){
this.prototype	= RDFAPI_Model;
this.prototype(storeURL, storage);
this.className	= 'RDFAPI_NSIModel';
this.store		= new RDFAPI_NSIStore(this.storeURL, this.storage);
}//</m>RDFAPI_NSIModel



//================
this.setStatement = function		//<m>boolean(int)<a>public<d>Setup this statement in the model
(
statement,		//<p>Object<d>Statement to assert
method			//<p>string<d>Assertion method: assert || unassert
){
try{
	this.getStore()[method](
		statement[this.K.AT_PREDICATE],
		statement[this.K.AT_SUBJECT],
		statement[this.K.AT_OBJECT],
		this.preserving);
	return this.K.ERROR.NONE;
	}
catch(e){
	return this.K.ERROR.NO_SUCCESS;
	}
}//</m>setStatement



//================
this.testStatementMatch = function		//<m>int<a>public<d>Check whether a statement matches another one
(
statement,		//RDFAPI_Statement<d>Statement to be matched
subject,		//<p>RDFAPI_Resouce<d>Statement subject -- can be a RegExp
predicate,		//<p>RDFAPI_Resouce<d>Statement predicate -- can be a RegExp
object,			//<p>Object<d>Statement object -- can be a RegExp
excluding		//<p>boolean=false<d>Exclusion flag: NOT AND (XOR) || AND
){
var
/*boolean*/matching = !excluding;
if(predicate){
	if(predicate instanceof RegExp){
		if(!statement[this.K.AT_PREDICATE].Value.match(predicate)) return !matching;
		}
	else{
		if(!predicate.EqualsNode(statement[this.K.AT_PREDICATE])) return !matching;
		}
	}
if(subject){
	if(subject instanceof RegExp){
		if(!statement[this.K.AT_SUBJECT].Value.match(subject)) return !matching;
		}
	else{
		if(!subject.EqualsNode(statement[this.K.AT_SUBJECT])) return !matching;
		}
	}
if(object){
	if(object instanceof RegExp){
		if(!statement[this.K.AT_OBJECT].Value.match(object)) return !matching;
		}
	else{
		if(!object.EqualsNode(statement[this.K.AT_OBJECT])) return !matching;
		}
	}
return matching;
}//</m>testStatementMatch



this.RDFAPI_NSIModel(_storeURL, _storage);
}//</c>RDFAPI_NSIModel

