/*
 * The contents of this file are
 * published under the Mozilla Public License 1.1
 */
//@@@@@@@@@@@@@@@@
function RDFAPI_SetModel		//<c><e>RDFAPI_Store<a>protected<d>RDF set model class
(){
const ASSERTING = false;
//================
this.RDFAPI_SetModel = function		//<m>void<a>private<d>class constructor
(){
this.className	= 'RDFAPI_SetModel';
}//</m>RDFAPI_SetModel



//================
this.getUnion = function		//<m>RDFAPI_Model<a>public<d>Get the union of 2 models
(
first,		//<p>RDFAPI_Model<d>First model to unite
second		//<p>RDFAPI_Model<d>Second model to unite
){
var
/*RDFAPI_Model*/model = first.getDuplicata(),
statementSet = second.getStatementSet();
for(var i=0,m=statementSet.length;i<m;i++) model.setAddStatement(statementSet[i]);
return model;
}//</m>getUnion<d>&
/*
Original models are not modified
*/



//================
this.getSubstraction = function		//<m>RDFAPI_Model<a>public<d>Get the substraction of 2 models
(
first,		//<p>RDFAPI_Model<d>First model to unite
second		//<p>RDFAPI_Model<d>Second model to unite
){
var
/*RDFAPI_Model*/model = first.getDuplicata(),
statementSet = second.getStatementSet();
for(var i=0,m=statementSet.length;i<m;i++) model.setRemoveStatement(statementSet[i]);
return model;
}//</m>getSubstraction<d>&
/*
Original models are not modified
*/



//================
this.getIntersection = function		//<m>RDFAPI_Model<a>public<d>Get the intersection of 2 models
(
first,		//<p>RDFAPI_Model<d>First model to unite
second		//<p>RDFAPI_Model<d>Second model to unite
){
var
/*RDFAPI_Statement*/statement,
/*RDFAPI_Model*/model = first.getDuplicata(),
statementSet = second.getStatementSet();
for(var i=0,m=statementSet.length;i<m;i++){
	statement = statementSet[i];
	if(!first.testOccurence(statement)) model.setRemoveStatement(statement);
	}
statementSet = model.getStatementSet();
for(var i=0,m=statementSet.length;i<m;i++){
	statement = statementSet[i];
	if(!second.testOccurence(statement)) model.setRemoveStatement(statement);
	}
return model;
}//</m>getIntersection<d>&
/*
Original models are not modified
*/



this.RDFAPI_SetModel();
}//</c>RDFAPI_SetModel

