/*
 * The contents of this file are
 * published under the Mozilla Public License 1.1
 */
//@@@@@@@@@@@@@@@@
function RDFAPI_SetStore		//<c><a>public<d>Model set storage class
(){
//================
this.RDFAPI_SetStore = function		//<m>void<a>private<d>class constructor
(){
this.className		= 'RDFAPI_SetStore';
//i12n
this.errorNotifier	= new ERROR_Notifier(this.className);
this.compositeSet	= null;
this.storeSet		= [];
}//</m>RDFAPI_SetStore



//=================
this.set_compositeSet = function		//<m>Object<a>public<d>Set up the compositeSet member
(){
try{
	this.compositeSet = XPConnector.getService('nsIRDFCompositeDataSource');
	return this.K.ERROR.NONE
	}
catch(e){
	return this.errorNotifier.setOut(e, this.K.ERROR.SERVICE_ACCESS);
	}
}//</m>set_compositeSet



//=================
this.setStore = function		//<m>(boolean)int<a>public<d>Add or remove a store from the set
(
model,			//<p>RDFAPI_Model<d>Model to compose with
compositing		//<p>boolean<d>Compose flag: add || remove
){
if(!this.compositeSet) this.set_compositeSet();
try{
	var
	/*string*/uri = model.getSourceURI();
	if(!uri) throw this.K.ERROR.STORE_ACCESS;		//need an URI for storeSet hash
	var
	/*Object*/store = model.getStore();
	this.compositeSet[compositing ? 'AddDataSource' : 'RemoveDataSource'](store);
	this.storeSet[uri] = compositing ? store : null;
	return this.K.ERROR.NONE;
	}
catch(e){
	return this.errorNotifier.setOut(e, this.K.ERROR.STORE_ACCESS);
	}
}//</m>setStore



//================
this.setOut = function		//<m>void<a>public<d>Flush all models in set
(){
for(var k in this.storeSet) this.storeSet[k].setOut();
}//</m>setOut



//================
this.getStore = function		//<m>Object<a>public<d>Get the store of a specific model
(
model		//<p>RDFAPI_Model<d>Model
){
return this.storeSet[model.getSourceURI()];
}//</m>getStore



//=================
this.get_storeSet = function		//<m>Object<a>public<d>Get the storeSet member
(){
return this.storeSet;
}//</m>get_storeSet



//=================
this.getStoreSet = function		//<m>Object<a>public<d>Get an iterator of the composite set
(){
try{
	return this.compositeSet.GetDataSources();
	}
catch(e){
	return null;
	}
}//</m>getStoreSet



this.K =
	{
	ERROR:
		{
		//NON FATAL
		NONE:					0,
		NO_SUCCESS:				1,

		//FATAL
		SERVICE_ACCESS:			-1,
		FATAL:					0xFF		//end of error codes
		}
	};
this.RDFAPI_SetStore();
}//</c>RDFAPI_SetStore

